----------------------------------------------
-- Sol4Box.lua
-- by Lygin Gennady a.k.a. Croc 22.10.2014
-- Edit by Patrick Ziegler a.k.a. Gironde 07-04-2017
---------------------------------------------
require "locale"
require "closeButton"
require "pCXBox"
----------------------------------------------
-- Set initial values
----------------------------------------------
local obs = celestia:getobserver()
local newwidth, newheight
local gn=42
local gg=gn-1
local Sol4FrameWidth, Sol4FrameHeight = 170, 14*gn+4
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
Sol4Box = CXBox:new()    
  --  :fillcolor(cFrameFill)
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

Sol4Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-3, 9)  
    :text(_("So4"))
    :movable(false)
    :visible(false) 
    :active(true) 
    :attach(Sol4Box,0,0,0,0) 

Sol4Check = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)       
        :textcolor({1,0,0,0.8})
        :textpos("left")
        :movetext(-32, 9)
        :text("")
        :movable(false)
        :active(true)  
        :attach(Sol4Box, 20, 0, 0, 0)

Sol4Box.Customdraw = function(this) -- add this lines by Gironde 08-04-2017
    Sol4Button.Visible = GuidesVisibility -- display or undisplay Button
    Sol4Check.Visible = GuidesVisibility  -- display or undisplay Check
    if Sol4Check.Text ==  "o" then
		Sol4Frame.Visible = GuidesVisibility -- display or undisplay Frame
    end
 end
 
Sol4Button.Action = (function()
        return
            function()
              display_Sol4= not display_Sol4
                if display_Sol4 then                    				
                    Sol4Frame.Visible = true                    
                    Sol4Check.Text = "o"
                    celestia:seturl("cel://Follow/Sol:Earth/2018-08-30T01:33:09.98159?x=qNQ6ImMQAf///////////w&y=EP9xrYdu&z=MHPOzLVRt////////////w&ow=0.602419&ox=0.00489157&oy=0.798161&oz=-0.00267168&select=Sol:Earth&fov=36.4986&ts=1&ltd=0&p=0&rf=2098579&lm=2178&tsrc=0&ver=3")					
                    celestia:show("stars")
                    celestia:setstarstyle("point")
					else
                    Sol4Frame.Visible = false                  
                    Sol4Check.Text = ""
                    celestia:seturl("cel://Follow/Sol:Earth/2018-08-30T01:33:09.98159?x=qNQ6ImMQAf///////////w&y=EP9xrYdu&z=MHPOzLVRt////////////w&ow=0.602419&ox=0.00489157&oy=0.798161&oz=-0.00267168&select=Sol:Earth&fov=36.4986&ts=1&ltd=0&p=0&rf=2098579&lm=2178&tsrc=0&ver=3")					
                    celestia:show("stars")
                    celestia:setstarstyle("point") 
                end
            end
        end) () 
---------------------------------
Sol4Frame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(color83)  
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-Sol4FrameWidth)/2, height-Sol4FrameHeight-2, (width-Sol4FrameWidth)/2, 2)

 Sol4Frame.Customdraw = function(this) 

            if Sol4_firstTickDone then
            if not(Sol4CloseButtonDone) then
                Sol4CloseButtonDone = true
                makeCloseButton(Sol4CloseButton, Sol4Frame, Sol4Button)
            end
            else
                Sol4_firstTickDone = true            
            end     

            if newwidth ~= width or newheight ~= height then
                    newwidth, newheight = width, height
               if height>=768  then               
                    Sol4Frame:attach(screenBox, width-Sol4FrameWidth-36, height-Sol4FrameHeight-128-27, 36, 128+27)  
               else
                    Sol4Frame:attach(screenBox, width-Sol4FrameWidth-200, height-Sol4FrameHeight-3, 200, 3)
                end                 
            end
         
	    textlayout:setfont(normalfont)
            textlayout:setfontcolor({0.2,0.8,1,1})        
	    textlayout:setpos(this.lb+45, this.tb - 14)         
            textlayout:println(_("    STUDY-2"))
            textlayout:setpos(this.lb+20, this.tb - 28)         
            textlayout:println(_("of Comets & Asteroids"))
end
-- =================
-- Подключение команд 
-- =================
  Sol4102Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Object / Country / Device / Date:"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-2), 2, 5+14*2)
--=================
Sol4103Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-3), 129, 5+14*3)
	
Sol4203Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Deep Impact"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-3), 49, 5+14*3)

Sol4203Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Deep Impact")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Deep%20Impact/Sol:Earth/2005-02-25T23:55:49.58426?x=OnLY3DP//////////////w&y=OtyOpQ&z=kNKo8v///////////////w&ow=0.515663&ox=0.485454&oy=0.514259&oz=-0.483698&track=Sol:Deep%20Impact&select=Sol:Deep%20Impact&fov=0.332993&ts=1000&td=0&p=0&rf=2167987&lm=134&tsrc=0&ver=3")
               celestia:setambient (1.0)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()

Sol4303Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("12-01-05"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-3), 2, 5+14*3)
--=====================
Sol4104Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Comet"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-4), 129, 5+14*4)
	
Sol4104Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Deep Impact")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Deep%20Impact/Sol:Tempel%201/2005-07-06T06:11:37.89547?x=WNUxnP///////////////w&y=ud7W3v///////////////w&z=IP51Ng&ow=0.549294&ox=0.367595&oy=0.606293&oz=-0.44222&track=TYC%209836-3366-0&select=Sol:Tempel%201&fov=35.5296&ts=500&ltd=0&p=0&rf=2200755&lm=130&tsrc=0&ver=3")
               celestia:setambient (0.75)
	           celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()
	
Sol4204Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Tempel 1"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-4), 49, 5+14*4)
	
Sol4304Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("06-07-05"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-4), 2, 5+14*4)	
--=================
Sol4105Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)    
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Impactor"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-5), 112, 5+14*5)

Sol4105Box.Action = (function()
    return 
        function()  
            local obj = celestia:find("9P") 
            celestia:select(obj) 
            local obj = celestia:find("Impactor")           
            celestia:select(obj)            
            if not(empty(obj)) then
   			   celestia:seturl("cel://PhaseLock/Sol:Impactor/Sol/2005-07-04T04:01:06.03069?x=G8xhMQ&y=aqSQag&z=hluj7////////////////w&ow=0.595425&ox=0.754313&oy=0.000659277&oz=0.276551&track=Sol:Impactor&select=Sol:Impactor&fov=67.9233&ts=1&ltd=0&p=0&rf=2200723&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.2)
               obj1 = celestia:find("9P")
               obj1:mark("blue", "circle", 40)	
		       obs:center(obj)
            end
        end
    end) ()
	
Sol4205Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-4, 10)
    :text(_("04-07-2005 / 04: 00: 00"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 48, 2+14*(gg-5), 2, 5+14*5)	
--=================
Sol4106Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Impactor"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-6), 129, 5+14*6)
	
Sol4106Box.Action = (function()
    return 
        function()  
            local obj = celestia:find("9P") 
            celestia:select(obj) 
            local obj = celestia:find("Impactor")           
            celestia:select(obj)            
            if not(empty(obj)) then
   			   celestia:seturl("cel://PhaseLock/Sol:Impactor/Sol:Tempel%201/2005-07-04T04:31:05.67456?x=bkC4AGz4/////////////w&y=2bBo7P///////////////w&z=G8St7////////////////w&ow=0.687592&ox=0.164904&oy=0.687621&oz=-0.164925&track=Sol:Impactor&select=Sol:Impactor&fov=0.0153353&ts=1&ltd=0&p=0&rf=2200723&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.2)
		       obs:center(obj)
            end
        end
    end) ()

Sol4306Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("04-07-2005 / 04: 30: 00"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 48, 2+14*(gg-6), 2, 5+14*6)
--=================
Sol4107Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)    
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Impactor"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-7), 112, 5+14*7)	
	
Sol4107Box.Action = (function()
    return 
        function()  
            local obj = celestia:find("9P") 
            celestia:select(obj) 
            local obj = celestia:find("Impactor")           
            celestia:select(obj)            
            if not(empty(obj)) then
   			   celestia:seturl("cel://PhaseLock/Sol:Impactor/Sol:Tempel%201/2005-07-04T06:00:58.16267?x=UE0Jkf///////////////w&y=uanP3f///////////////w&z=7qKXCA&ow=0.63672&ox=0.307551&oy=0.63672&oz=-0.307551&track=Sol:Tempel%201&select=Sol:Tempel%201&fov=0.00211791&ts=0.1&ltd=0&p=0&rf=2200723&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.2)
		       obs:center(obj)
            end
        end       
    end) ()	
	
Sol4207Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("04-07-2005 / 05: 59: 53"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 48, 2+14*(gg-7), 2, 5+14*7)
--=================	
Sol4108Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-8), 129, 5+14*8)
	
Sol4208Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-8), 49, 5+14*8)
	
Sol4308Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-8), 2, 5+14*8)
--=================	
Sol4109Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-9), 129, 5+14*9)

Sol4209Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Dawn"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-9), 49, 5+14*9)

Sol4209Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Dawn")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Dawn/Sol:Earth/2007-09-27T13:02:22.07944?x=SVbB2+j//////////////w&y=uiJAGf///////////////w&z=CView////////////////w&ow=-0.583945&ox=0.398758&oy=-0.583945&oz=-0.398758&track=Sol:Earth&select=Sol:Earth&fov=14.998&ts=100&ltd=0&p=0&rf=2168211&lm=4226&tsrc=0&ver=3")
               celestia:setambient (1.0)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj)
            end
        end
    end) ()

Sol4309Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("27-09-07"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-9), 2, 5+14*9)
--=================	
Sol4110Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("asteroid"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-10), 129, 5+14*10)
	
Sol4110Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Dawn")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Earth/Sol:Vesta/2011-07-17T02:20:21.08605?x=mCy/iKvMTV4U&y=SxMZynfQ/f///////////w&z=A6hVX2Ad&ow=0.300082&ox=0.640274&oy=-0.300083&oz=0.640274&track=Sol:Earth&select=Sol:Vesta&fov=0.0128532&ts=200&ltd=0&p=0&rf=2102675&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.75)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()
	
Sol4210Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Vesta"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-10), 49, 5+14*10)
	
Sol4310Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("17-11-11"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-10), 2, 5+14*10)	
--=================	
Sol4111Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("dwarf pl."))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-11), 129, 5+14*11)
	
Sol4111Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Dawn")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Dawn/Sol:Ceres/2015-12-15T23:00:44.97048?x=jDIvzff//////////////w&y=+anFj////////////////w&z=ZHZubv///////////////w&ow=-0.589723&ox=0.390162&oy=-0.589724&oz=-0.390161&track=Sol:Ceres&select=Sol:Ceres&fov=84.5788&ts=25&ltd=0&p=0&rf=2102419&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.5)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()
	
Sol4211Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Ceres"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-11), 49, 5+14*11)
	
Sol4311Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("15-12-15"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-11), 2, 5+14*11)	
--=================	
Sol4112Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("China"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-12), 129, 5+14*12)

Sol4212Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(color2)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Chang'e 2"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-12), 49, 5+14*12)

Sol4212Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Chang'e 2")           
            celestia:select(obj)            
            if not(empty(obj)) then
               obs:follow(obj)
               obs:goto(obj) 
               celestia:settimescale(1)  
            end
        end
    end) ()

Sol4312Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("01-10-10"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-12), 2, 5+14*12)
--=================
Sol4113Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("asteroid"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-13), 129, 5+14*13)
	
Sol4113Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Toutatis")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Toutatis/2012-12-13T15:54:33.71880?x=+4DTUn0O&y=IFJHH+P//////////////w&z=UYwkDVb6/////////////w&ow=0.563875&ox=-0.000625288&oy=-0.82585&oz=0.00396292&track=Sol:Toutatis&select=Sol:Toutatis&fov=36.4986&ts=10000&ltd=0&p=0&rf=2135955&lm=4226&tsrc=0&ver=3")
               celestia:setambient (0.75)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()	
	
Sol4213Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Toutatis"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-13), 49, 5+14*13)
	
Sol4313Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("13-12-12"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-13), 2, 5+14*13)
--=================
Sol4114Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Jap"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-14), 129, 5+14*14)

Sol4214Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Hayabusa-2"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-14), 49, 5+14*14)

Sol4214Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Hayabusa-2")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Hayabusa-2/Sol:Earth/2014-12-03T06:31:10.56873?x=bVo4/f3//////////////w&y=nQHQ7v///////////////w&z=n/5fy////////////////w&ow=-0.637539&ox=0.25232&oy=-0.697966&oz=-0.206694&track=Sol:Hayabusa-2&select=Sol:Hayabusa-2&fov=50.4588&ts=50&ltd=0&p=0&rf=2200979&lm=6278&tsrc=0&ver=3")
               celestia:setambient (1.0)
	           celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj)
            end
        end
    end) ()    

Sol4314Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("03-12-14"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-14), 2, 5+14*14)
--=================	
Sol4115Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("asteroid"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-15), 129, 5+14*15)
	
Sol4115Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Hayabusa-2")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://Follow/Sol:Hayabusa-2/2014-12-03T10:29:03.52511?x=AADK/5obpzch&y=AADwk3sAYvGM&z=AIB9TFE90HgM&ow=0.52847&ox=0.640881&oy=0.311509&oz=0.461468&track=Sol&select=Sol:Hayabusa-2&fov=17.6562&ts=100000&ltd=0&p=0&rf=2201011&lm=6278&tsrc=0&ver=3")
               celestia:setambient (0.75)
               obj1 = celestia:find("Hayabusa-2")
               obj1:mark("green", "square", 40)
               obj2 = celestia:find("Ryugu")
               obj2:mark("blue", "circle", 40)  
			   celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj) 
            end
        end
    end) ()	
	
Sol4215Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Ryugu"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-15), 49, 5+14*15)
	
Sol4315Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("07-07-18"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-15), 2, 5+14*15)
--=================
Sol4116Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("USA"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-16), 129, 5+14*16)

Sol4216Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("OSIRIS-REx"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-16), 49, 5+14*16)
	
Sol4216Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("OSIRIS-REx")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:OSIRIS-REx/Sol:Earth/2017-08-23T20:10:56.94660?x=74HnYK33/////////////w&y=iqAZZgE&z=krlzeP7//////////////w&ow=-0.46373&ox=0.533553&oy=-0.464414&oz=-0.533475&track=Sol:OSIRIS-REx&select=Sol:OSIRIS-REx&fov=0.201166&ts=1000&ltd=0&p=0&rf=2135443&lm=6310&tsrc=0&ver=3")
               celestia:setambient (0.9)
               celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj)  
            end
        end
    end) ()	

Sol4316Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)    
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("08-09-16"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-16), 2, 5+14*16)
--=================	
Sol4117Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("asteroid"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 2, 2+14*(gg-17), 129, 5+14*17)
	
Sol4117Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("OSIRIS-REx")           
            celestia:select(obj)            
            if not(empty(obj)) then
			   celestia:seturl("cel://PhaseLock/Sol:Bennu/Sol:Earth/2017-08-29T08:48:43.70244?x=Wyec2sSg8////////////w&y=bP7CcVEB&z=QilhReD//////////////w&ow=-0.463247&ox=0.53404&oy=-0.463488&oz=-0.534212&track=Sol:Bennu&select=Sol:Bennu&fov=0.0463791&ts=500&ltd=0&p=0&rf=2135443&lm=6310&tsrc=0&ver=3")
               celestia:setambient (0.9)
	           celestia:setorbitflags{Moon = true} -- луны		
               obs:center(obj)  
            end
        end
    end) ()	
	
Sol4217Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("Bennu"))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-17), 49, 5+14*17)
	
Sol4317Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_("29-08-17"))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-17), 2, 5+14*17)
--=================
Sol4118Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-18), 129, 5+14*18)

Sol4218Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-18), 49, 5+14*18)

Sol4318Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-18), 2, 5+14*18)
--=================	
Sol4119Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-19), 129, 5+14*19)
	
Sol4219Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-19), 49, 5+14*19)
	
Sol4319Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-19), 2, 5+14*19)
--=================	
Sol4120Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-20), 129, 5+14*20)

Sol4220Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-20), 49, 5+14*20)

Sol4320Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-20), 2, 5+14*20)
--=================	
Sol4121Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-21), 129, 5+14*21)
	
Sol4221Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-21), 49, 5+14*21)
	
Sol4321Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-21), 2, 5+14*21)
--=================	
Sol4122Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-22), 129, 5+14*22)

Sol4222Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-22), 49, 5+14*22)

Sol4322Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-22), 2, 5+14*22)
--=================	
Sol4123Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-23), 129, 5+14*23)
	
Sol4223Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-23), 49, 5+14*23)
	
Sol4323Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-23), 2, 5+14*23)
--=================	
Sol4124Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-24), 129, 5+14*24)

Sol4224Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-24), 49, 5+14*24)

Sol4324Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-24), 2, 5+14*24)
--=================	
Sol4125Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-25), 129, 5+14*25)
	
Sol4225Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-25), 49, 5+14*25)
	
Sol4325Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-25), 2, 5+14*25)
--=================	
Sol4126Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-26), 129, 5+14*26)

Sol4226Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-26), 49, 5+14*26)

Sol4326Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-26), 2, 5+14*26)
--=================	
Sol4127Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-27), 129, 5+14*27)
	
Sol4227Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-27), 49, 5+14*27)
	
Sol4327Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-27), 2, 5+14*27)
--=================	
Sol4128Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-28), 129, 5+14*28)

Sol4228Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-28), 49, 5+14*28)

Sol4328Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-28), 2, 5+14*28)
--=================	
Sol4129Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-29), 129, 5+14*29)
	
Sol4229Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-29), 49, 5+14*29)
	
Sol4329Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-29), 2, 5+14*29)
--=================	
Sol4130Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-30), 129, 5+14*30)

Sol4230Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-30), 49, 5+14*30)

Sol4330Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-30), 2, 5+14*30)
--=================	
Sol4131Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-31), 129, 5+14*31)
	
Sol4231Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-31), 49, 5+14*31)
	
Sol4331Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-31), 2, 5+14*31)
--=================	
Sol4132Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-32), 129, 5+14*32)

Sol4232Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-32), 49, 5+14*32)

Sol4332Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-32), 2, 5+14*32)
--=================	
Sol4133Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-33), 129, 5+14*33)
	
Sol4233Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-33), 49, 5+14*33)
	
Sol4333Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-33), 2, 5+14*33)
--=================	
Sol4134Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-34), 129, 5+14*34)

Sol4234Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-34), 49, 5+14*34)

Sol4334Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-34), 2, 5+14*34)
--=================	
Sol4135Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-35), 129, 5+14*35)
	
Sol4235Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-35), 49, 5+14*35)
	
Sol4335Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-35), 2, 5+14*35)
--=================	
Sol4136Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-36), 129, 5+14*36)

Sol4236Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-36), 49, 5+14*36)

Sol4336Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-36), 2, 5+14*36)
--=================	
Sol4137Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-37), 129, 5+14*37)
	
Sol4237Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-37), 49, 5+14*37)
	
Sol4337Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-37), 2, 5+14*37)
--=================	
Sol4138Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-38), 129, 5+14*38)

Sol4238Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-38), 49, 5+14*38)

Sol4338Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-38), 2, 5+14*38)
--=================	
Sol4139Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-39), 129, 5+14*39)
	
Sol4239Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-39), 49, 5+14*39)
	
Sol4339Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-39), 2, 5+14*39)
--=================	
Sol4140Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-40), 129, 5+14*40)

Sol4240Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 43, 2+14*(gg-40), 49, 5+14*40)

Sol4340Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)  
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 123, 2+14*(gg-40), 2, 5+14*40)
--=================	
Sol4141Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 2, 2+14*(gg-41), 129, 5+14*41)
	
Sol4241Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)  
   -- :textcolor(cbutextoff)
    :textcolor({0.55,0.38,0.22,1})	
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(false) 
    :attach(Sol4Frame, 43, 2+14*(gg-41), 49, 5+14*41)
	
Sol4341Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont)   
    :textcolor(cbutextoff)
    :textpos("left")    
    :movetext(-3, 10)
    :text(_(""))
    :movable(false)
    :active(true) 
    :attach(Sol4Frame, 123, 2+14*(gg-41), 2, 5+14*41)
--=================	